#!/usr/bin/env python

from re import compile as recompile
from sss.ssslib import comm_lib
from string import join, split
from sys import argv, exit
from xml.dom.minidom import parseString, Document

def usage():
    print "Usage:\nnsmclient.py get -r restrictions\n or\nnsmclient.py set key=value -r restrictions\n or\nnsmclient.py del -r restrictions\n or\nnsmclient.py add values\nnsmclient.py diag key=value -r restrictions\n"
    exit(1)

getargre = recompile("^(-d ){0,1}get -r (?P<restrictions>(\S+=\S+ {0,1})*)$")
setargre = recompile("^(-d ){0,1}set (?P<update>\S+=\S+) -r (?P<restrictions>(\S+=\S+ {0,1})*)$")
addargre = recompile("^(-d ){0,1}add (?P<values>(\S+=\S+ {0,1})+)$")
delargre = recompile("^(-d ){0,1}del -r (?P<restrictions>(\S+=\S+ {0,1})*)$")
diagargre = recompile("^(-d ){0,1}diag (?P<values>(\S+=\S+ {0,1})+) -r (?P<restrictions>(\S+=\S+ {0,1})*)$")
argstring = join(argv[1:]," ")

if getargre.match(argstring):
    restrictions = getargre.match(argstring).group("restrictions")
    reqdoc = Document()
    wrapper = reqdoc.createElement("get-node-state")
    newel = reqdoc.createElement("node-state")
    map(lambda x:newel.setAttribute(x,"*"), ['node','state','adminstate'])
    for rest in split(restrictions):
        newel.setAttribute(split(rest,"=")[0],split(rest,"=")[1])
    wrapper.appendChild(newel)
    reqdoc.appendChild(wrapper)
    action = "get"
elif setargre.match(argstring):
    restrictions = setargre.match(argstring).group("restrictions")
    update = setargre.match(argstring).group("update")
    reqdoc = Document()
    wrapper = reqdoc.createElement("set-node-state")
    newel = reqdoc.createElement("node-state")
    map(lambda x:newel.setAttribute(x,"*"), ['node','state','adminstate'])
    for rest in split(restrictions):
        newel.setAttribute(split(rest,"=")[0],split(rest,"=")[1])
    wrapper.appendChild(newel)
    wrapper.setAttribute(split(update,"=")[0],split(update,"=")[1])
    reqdoc.appendChild(wrapper)
    action = "set"
elif addargre.match(argstring):
    values = addargre.match(argstring).group("values")
    reqdoc = Document()
    wrapper = reqdoc.createElement("add-node-state")
    newel = reqdoc.createElement("node-state")
    for rest in split(values):
        newel.setAttribute(split(rest,"=")[0],split(rest,"=")[1])
    wrapper.appendChild(newel)
    reqdoc.appendChild(wrapper)
    action = "add"
elif delargre.match(argstring):
    restrictions = delargre.match(argstring).group("restrictions")
    reqdoc = Document()
    wrapper = reqdoc.createElement("del-node-state")
    newel = reqdoc.createElement("node-state")
    map(lambda x:newel.setAttribute(x,"*"), ['node','state','adminstate'])
    for rest in split(restrictions):
        newel.setAttribute(split(rest,"=")[0],split(rest,"=")[1])
    wrapper.appendChild(newel)
    reqdoc.appendChild(wrapper)
    action = "del"
elif diagargre.match(argstring):
    restrictions = diagargre.match(argstring).group("restrictions")
    values = diagargre.match(argstring).group("values")
    reqdoc = Document()
    wrapper = reqdoc.createElement("diagnose")
    for value in split(values):
        wrapper.setAttribute(split(value,"=")[0],split(value,"=")[1])
    newel = reqdoc.createElement("node-state")
    map(lambda x:newel.setAttribute(x,"*"), ['node','state','adminstate'])
    for rest in split(restrictions):
        newel.setAttribute(split(rest,"=")[0],split(rest,"=")[1])
    wrapper.appendChild(newel)
    reqdoc.appendChild(wrapper)
    action = "diag"
else:
    usage()
    
sss = comm_lib(debug=('-d' in argv))
handle = sss.ClientInit("node-state-manager")
sss.SendMessage(handle,reqdoc.toxml())
msg = sss.RecvMessage(handle)
sss.ClientClose(handle)
del sss
try:
    domobj = parseString(msg)
except:
    print "server error"
    exit(1)
    
if domobj.getElementsByTagName("node-state"):
    fields=domobj.getElementsByTagName("node-state")[0]._attrs.keys()
    results=[tuple(fields)]
    for record in domobj.getElementsByTagName("node-state"):
        results.append(tuple(map(lambda x:record.getAttribute(x), fields)))
    lendata=map(lambda x:map(len,x),results)
    fsizes=tuple(map(lambda i:apply(max,map(lambda x:x[i],lendata)),range(len(lendata[0]))))
    fstring=join(['%%%ss']*len(fsizes),'   ')%(fsizes)
    i=0
    for data in results:
        print fstring%data
        if not i:
            print "================================================================================"
            i=1
    

