#!/usr/bin/env python

from SocketServer import ThreadingTCPServer,BaseRequestHandler
from sys import argv,path
path.append("../../lib")
from BetterThreadingTCPServer import BetterThreadingTCPServer
from string import split,rstrip
from os import getpid, fork
from time import time
from xml.dom.minidom import Document, parseString
path.append("SSS_LIBPATH_APPEND")
from nodecomm_lib import identify,build,diagnostic

comm_module_dispatch = {'identify':identify,
                        'build':build,
                        'diagnostic':diagnostic}

class Handler(BaseRequestHandler):
    def handle(self):
        print "starting handler"
        sockfile = self.request.makefile()
        msg = sockfile.readline()
        msg = rstrip(msg)
	print "msg from client is :%s:"%msg
        comm_module_dispatch[msg](self.request,sockfile)
	print "exiting handler"
        
server = BetterThreadingTCPServer(('',1234),Handler)

if __name__ == "__main__":
    if '-daemon' in argv:
        pid = fork()
        if pid:
            file = open(argv[-1],"w")
            file.write("%i"%pid)
            file.close()
        else:
            try:
                server.serve_forever()
            except KeyboardInterrupt:
                del server
    else:
        try:
            server.serve_forever()
        except KeyboardInterrupt:
            del server
        

